/****************************************************************************
 * @source      :
 * @description :
 ****************************************************************************
 * DATE         AUTHOR    DESCRIPTION
 * --------------------------------------------------------------------------
 * 2011/12/24   정승호    최초작성
 *
 ****************************************************************************/
//---------------------------------------------------------------------------

#include <vcl.h>
#include "ITSSkinF.h"
#include "ITSUtilF.h"
#include "AppGlobalF.h"
#include "CDSCodeF.h"
#include "CDSFacilityF.h"
#include "XiMapUtilF.h"
#pragma hdrstop

#include "DSRM010MF.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cxButtons"
#pragma link "cxCalendar"
#pragma link "cxContainer"
#pragma link "cxControls"
#pragma link "cxDropDownEdit"
#pragma link "cxEdit"
#pragma link "cxGraphics"
#pragma link "cxGroupBox"
#pragma link "cxLabel"
#pragma link "cxLookAndFeelPainters"
#pragma link "cxLookAndFeels"
#pragma link "cxMaskEdit"
#pragma link "cxPC"
#pragma link "cxPCdxBarPopupMenu"
#pragma link "cxSpinEdit"
#pragma link "cxSplitter"
#pragma link "cxTextEdit"
#pragma link "cxTimeEdit"
#pragma link "dxSkinBlack"
#pragma link "dxSkinBlue"
#pragma link "dxSkinCaramel"
#pragma link "dxSkinCoffee"
#pragma link "dxSkinDarkRoom"
#pragma link "dxSkinDarkSide"
#pragma link "dxSkinFoggy"
#pragma link "dxSkinGlassOceans"
#pragma link "dxSkiniMaginary"
#pragma link "dxSkinLilian"
#pragma link "dxSkinLiquidSky"
#pragma link "dxSkinLondonLiquidSky"
#pragma link "dxSkinMcSkin"
#pragma link "dxSkinMoneyTwins"
#pragma link "dxSkinOffice2007Black"
#pragma link "dxSkinOffice2007Blue"
#pragma link "dxSkinOffice2007Green"
#pragma link "dxSkinOffice2007Pink"
#pragma link "dxSkinOffice2007Silver"
#pragma link "dxSkinOffice2010Black"
#pragma link "dxSkinOffice2010Blue"
#pragma link "dxSkinOffice2010Silver"
#pragma link "dxSkinsCore"
#pragma link "dxSkinscxPCPainter"
#pragma link "dxSkinSeven"
#pragma link "dxSkinSharp"
#pragma link "dxSkinSilver"
#pragma link "dxSkinStardust"
#pragma link "FRAME_DsrcListF"
#pragma link "cxRadioGroup"
#pragma link "cxClasses"
#pragma link "cxCustomData"
#pragma link "cxData"
#pragma link "cxDataStorage"
#pragma link "cxDBData"
#pragma link "cxFilter"
#pragma link "cxGrid"
#pragma link "cxGridCustomTableView"
#pragma link "cxGridCustomView"
#pragma link "cxGridDBTableView"
#pragma link "cxGridLevel"
#pragma link "cxGridTableView"
#pragma link "cxStyles"
#pragma link "FRAME_GisMapF"
#pragma link "cxCheckBox"
#pragma resource "*.dfm"

TDSRM010M *DSRM010M = NULL;
//---------------------------------------------------------------------------
__fastcall TDSRM010M::TDSRM010M(TComponent* Owner)
    : TForm(Owner)
{
    ITSSkin_Load(this);
    CMM_LoadForm(g_sFormsDir, this);

    FUpdate= false;
    FTitle = "DSRC-RSE 관리";
    FRAMEDsrcList1->PnlTop->Visible = false;
    FRAMEDsrcList1->PnlBottom->Visible = false;
    FRAMEDsrcList1->ColumnSel->Visible = false;
    //FRAMEDsrcList1->Column02->Visible = false;
    FRAMEGisMap1->LbDef->Caption = "(선택메뉴를 클릭하여 위치를 선택합니다.)";
    FRAMEGisMap1->LbDef->Hint = FRAMEGisMap1->LbDef->Caption;

    m_pGDC = FRAMEDsrcList1->TvList->DataController;
}
//---------------------------------------------------------------------------

/*
 * 닫기버튼 이나 x버튼 클릭시 공통으로 처리하는 로직이들어간다..
 * Form과 DataModule class를 delete시킨다.
 *  arguments
 *
 *  return
 *      void
 */
void __fastcall TDSRM010M::CommClose()
{
    try
    {
        CMM_SaveForm(g_sFormsDir, this);
    }
    catch(...)
    {
    }
}
//---------------------------------------------------------------------------

/*
 * Form을 보여줄때 호출되는 event 메서드이다.
 *  arguments
 *      Sender : event handler 객체
 *  return
 *      void
 */
void __fastcall TDSRM010M::FormShow(TObject *Sender)
{
    Refresh();

    CbMnfcCmpyCd->Properties->Items->Clear();
    TItsCode *FCodeRMF  = ItsCodeManager->FLists.Find("RMF");
    if (FCodeRMF)
    {
		FOR_STL(TItsSubCode *, pSubCode, FCodeRMF->FSubLists)
		{
			if (pSubCode->USE_YN == "N") continue;
			CbMnfcCmpyCd->Properties->Items->Add(" [" + pSubCode->CMMN_CD + "] " + pSubCode->CMMN_CD_KOR_NM);
		}
    }
	CbMnfcCmpyCd->ItemIndex = 0;

    FormInit();
    ChangeEditMode(1);
    TmrShow->Enabled = true;
}
//---------------------------------------------------------------------------

/*
 * form 초기화
 *
 *  arguments
 *
 *  return
 *      void
 */
void __fastcall TDSRM010M::FormInit()
{
	EdId->Text = "";
	EdRseId->Text = "";
	EdRoadSpotId->Text = "";
	EdLogCnncId->Text = "";
	EdLogCnncPwd->Text = "";
	EdIstlLctnNm->Text = "";
    SePosX->Value = 0;
    SePosY->Value = 0;
	EdIP->Text = "";
	EdPort->Text = "";
	CbMnfcCmpyCd->ItemIndex = 0;

    FNewDb = false;
}
//---------------------------------------------------------------------------

/*
 * Form이 Show되고 난 후 최초 1회 수행되는 타이머 이벤트
 *  arguments
 *      Sender : event handler 객체
 *  return
 *      void
 */
void __fastcall TDSRM010M::TmrShowTimer(TObject *Sender)
{
    TmrShow->Enabled = false;

    FRAMEGisMap1->LinkLevel = 1;
    FRAMEGisMap1->LoadGisMap();
    //FRAMEGisMap1->ShowHideTrafficLayer(false);
    UpdateRseIcon();

    FRAMEDsrcList1->UpdateList();
}
//---------------------------------------------------------------------------

/*
 * Close 버튼 클릭 이벤트 핸들러
 *  arguments
 *      Sender : event handler 객체
 *  return
 *      void
 */
void __fastcall TDSRM010M::BtnCloseClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::FormClose(TObject *Sender, TCloseAction &Action)
{
    CommClose();
    DSRM010M = NULL;
    Action = caFree;
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    if (FUpdate)
    {
        POST_MSG(Application->MainForm->Handle, WM_DATABASE_REFRESH, WP_MSG_14, 0);
    }

    FRAMEDsrcList1->OnCloseQuery(CanClose);
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::DisplayInfo(TItsDsrc* AObj)
{
    FormInit();

    if (!AObj) return;

    EdId->Text = AObj->ID;
    EdRseId->Text = AObj->RSE_ID;
    EdRoadSpotId->Text = AObj->ROAD_SPOT_ID;
    EdLogCnncId->Text = AObj->LOG_CNNC_ID;
    EdLogCnncPwd->Text = AObj->LOG_CNNC_PW;
    EdIstlLctnNm->Text = AObj->ISTL_LCTN_NM;
    SePosX->Value = StrToFloatDef(AObj->LCTN_X, 0);
    SePosY->Value = StrToFloatDef(AObj->LCTN_Y, 0);
    EdIP->Text = AObj->IP;
    EdPort->Text = AObj->PORT;

    SeCLCT_ABNR_BASI->Value = AObj->CLCT_ABNR_BASI;
    SeAbnrAll->Value = SeCLCT_ABNR_BASI->Value;

    CMM_SetComboBoxItem(CbMnfcCmpyCd, AObj->MNFC_CMPY_CD);

    FRAMEGisMap1->SelectObjectByPos(SePosX->Value, SePosY->Value, true);

    ChangeEditMode(3);
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::FRAMEGisMap1xclntMapMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Button != mbLeft) return;
    if (FRAMEGisMap1->xclntMap->MapOperation != OnSelect) return;

    FRAMEGisMap1->xclntMap->SetFocus();

	TDDPoint dptCurr = FRAMEGisMap1->xclntMap->ScreenToReal(Point( X, Y));

    try {
        SePosX->Value = dptCurr.X;
        SePosY->Value = dptCurr.Y;
    } catch(...) {}
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::UpdateRseIcon()
{
	FRAMEGisMap1->xclntMap->ClearCCTVEvent(true);

    TItsFacility *pFacility;
    try
    {
        if (ChkViewIcon->Checked)
        {
            try
            {
                FRAMEDsrcList1->MyItsDsrcManager->FLists.Lock();
                FOR_STL(TItsDsrc*, pObj, FRAMEDsrcList1->MyItsDsrcManager->FLists)
                {
                    if (pObj->DEL_YN == "Y") continue;

                    //pFacility = ItsFacilityManager->FLists.Find(pObj->ID);
                    //if (!pFacility) continue;

                    try {
                    String sTitle = "▶▶DSRC-RSE 정보◀◀|ID : " + pObj->ID + "|명칭 : " + pObj->ISTL_LCTN_NM;
                    FRAMEGisMap1->xclntMap->ADDCCTVEvent(DDPoint(StrToFloatDef(pObj->LCTN_X, 0), StrToFloatDef(pObj->LCTN_Y, 0)), pObj->ID, "", sTitle, 6, 1, 7);
                    } catch(...) { }
                }
            }
            __finally
            {
                FRAMEDsrcList1->MyItsDsrcManager->FLists.UnLock();
            }
        }
    }
    catch(...)
    {
    }

	FRAMEGisMap1->xclntMap->ReDraw();
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::FRAMEDsrcList1TvListCellDblClick(TcxCustomGridTableView *Sender, TcxGridTableDataCellViewInfo *ACellViewInfo,
          TMouseButton AButton, TShiftState AShift, bool &AHandled)
{
	if (!ACellViewInfo) return;
	int nRow = FRAMEDsrcList1->TvList->DataController->FocusedRecordIndex;
	if( nRow <= -1 )
		return;

    int nMemPtr = FRAMEDsrcList1->TvList->DataController->Values[nRow][FRAMEDsrcList1->Column99->Index];
    TItsDsrc* pObj = (TItsDsrc*)nMemPtr;
    DisplayInfo(pObj);
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::ChkViewIconClick(TObject *Sender)
{
    UpdateRseIcon();
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::BtnEditClick(TObject *Sender)
{
    if (BtnEdit->Caption == "편집")
    {
        ChangeEditMode(0);
        FNewDb = false;
    }
    else
    {
        String sId = EdId->Text;
        ChangeEditMode(1);

        TItsDsrc *pObj = FRAMEDsrcList1->MyItsDsrcManager->FLists.Find(sId);
        if (pObj)
        {
            CMM_SetGridRow(FRAMEDsrcList1->CxList, FRAMEDsrcList1->TvList, sId, FRAMEDsrcList1->Column01->Index);
            DisplayInfo(pObj);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::ChangeEditMode(int AEdit)
{
    bool bEnabled = false;
    switch(AEdit)
    {
    case 0: //편집버튼클릭
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = false;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = true;

            BtnEdit->Caption = "취소";
            BtnEdit->Hint    = "데이터 편집 취소";
        }
        break;
    case 1: //편집[취소]버튼클릭
        {
            FormInit(); //화면을 모두 지운다.
            BtnEdit->Enabled = false;
            BtnInsert->Enabled = true;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = false;

            BtnEdit->Caption = "편집";
            BtnEdit->Hint    = "데이터 편집";
            bEnabled = true;
        }
        break;
    case 2: //추가
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = false;
            BtnDelete->Enabled = false;
            BtnSave->Enabled = true;

            BtnEdit->Caption = "취소";
            BtnEdit->Hint    = "데이터 편집 취소";
        }
        break;
    case 3: //수정모드
        {
            BtnEdit->Enabled = true;
            BtnInsert->Enabled = true;
            BtnDelete->Enabled = true;
            BtnSave->Enabled = false;

            BtnEdit->Caption = "편집";
            BtnEdit->Hint    = "데이터 편집";
            bEnabled = true;
        }
        break;
    }

    if (AEdit == 0 || AEdit == 2)
    {
        FRAMEDsrcList1->CxList->Enabled = false;
    }
    else
    {
        FRAMEDsrcList1->CxList->Enabled = true;
    }

#if 1
	EdId->Properties->ReadOnly = bEnabled;
	EdRseId->Properties->ReadOnly = bEnabled;
	EdRoadSpotId->Properties->ReadOnly = bEnabled;
	EdLogCnncId->Properties->ReadOnly = bEnabled;
	EdLogCnncPwd->Properties->ReadOnly = bEnabled;
	EdIstlLctnNm->Properties->ReadOnly = bEnabled;
    SePosX->Properties->ReadOnly = bEnabled;
    SePosY->Properties->ReadOnly = bEnabled;
	EdIP->Properties->ReadOnly = bEnabled;
	EdPort->Properties->ReadOnly = bEnabled;
	CbMnfcCmpyCd->Properties->ReadOnly = bEnabled;

	SeCLCT_ABNR_BASI->Properties->ReadOnly = bEnabled;
#endif
}
//---------------------------------------------------------------------------


void __fastcall TDSRM010M::BtnInsertClick(TObject *Sender)
{
    FormInit();
    //신규아이디를 얻어와서 화면을 초기화한다.
    String sRseId;
    if (!FRAMEDsrcList1->MyItsDsrcManager->GetNextRseId(sRseId))
    {
        Application->MessageBox(L"새로운 RSE ID를 생성하지 못하였습니다.\r\n프로그램 종료후에 다시 시도해 보세요.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
        return;
    }

    EdId->Text = sRseId;
    EdRseId->Text = sRseId;
    ChangeEditMode(2);
    FNewDb = true;
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::BtnDeleteClick(TObject *Sender)
{
    int nIdx = m_pGDC->FocusedRecordIndex;
    if (nIdx < 0) return;

    String sId = EdId->Text;

    if (sId.IsEmpty())
    {
        Application->MessageBox(L"삭제할 DSRC-RSE를 목록에서 선택하세요.\r\n목록에서 더블클릭하여 선택합니다.", FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
        return;
    }
    String sMsg;
    sMsg = "ID: " + sId;
    sMsg+= "\r\n선택하신 DSRC-RSE 정보를 삭제하시겠습니까?";

    if (Application->MessageBox(sMsg.c_str(), FTitle.c_str(), MB_YESNO|MB_ICONQUESTION|MB_APPLMODAL) != IDYES) return;

	TItsDsrc *pObj = FRAMEDsrcList1->MyItsDsrcManager->FLists.Find(sId);

	if (pObj)
	{
		if (FRAMEDsrcList1->MyItsDsrcManager->DeleteDsrc(pObj))
		{
            pObj->DEL_YN = "Y";
            FRAMEDsrcList1->UpdateList();
		}

		TItsFacility *pFacility = ItsFacilityManager->FLists.Find(sId);
        if (pFacility)
        {
            FUpdate = true;
        }

        Application->MessageBox(L"DSRC-RSE 정보삭제\r\nDSRC-RSE 정보를 삭제 하였습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);

        FormInit();
        ChangeEditMode(1);
	}
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::BtnSaveClick(TObject *Sender)
{
	if (EdId->Text.IsEmpty()         ||
        EdRseId->Text.Trim().IsEmpty()      ||
        EdRoadSpotId->Text.IsEmpty() ||
        SePosX->Value == 0           ||
        SePosY->Value == 0           ||
        CbMnfcCmpyCd->Text.IsEmpty()  )
	{
        Application->MessageBox(L"★항목은 필수 입력 항목입니다.\r\n모두 입력후 진행해 주세요.",
                                FTitle.c_str(), MB_OK|MB_ICONERROR|MB_APPLMODAL);
		return;
	}

    String sId = EdId->Text;

    TItsDsrc *pObj;
    if (FNewDb)
        pObj = new TItsDsrc();
    else
        pObj = FRAMEDsrcList1->MyItsDsrcManager->FLists.Find(sId);

    if (pObj)
    {
        String sOldRseId   = pObj->RSE_ID;  //TODO

        pObj->ID           = sId;
        pObj->RSE_ID       = EdRseId->Text.Trim();
        pObj->ROAD_SPOT_ID = EdRoadSpotId->Text.Trim();
        pObj->LOG_CNNC_ID  = EdLogCnncId->Text.Trim();
        pObj->LOG_CNNC_PW  = EdLogCnncPwd->Text.Trim();
        pObj->ISTL_LCTN_NM = EdIstlLctnNm->Text.Trim();
        pObj->LCTN_X       = VarToStr(SePosX->Value);
        pObj->LCTN_Y       = VarToStr(SePosY->Value);
        pObj->IP           = EdIP->Text.Trim();
        pObj->PORT         = EdPort->Text.Trim();
        pObj->MNFC_CMPY_CD = ITSUtil_GetCode(CbMnfcCmpyCd->Text);

        pObj->CLCT_ABNR_BASI = (SeCLCT_ABNR_BASI->Value);

        pObj->Completed    = true;
        pObj->MEM_DEL      = "N";

        bool bResult;
        if (FNewDb)
        {
            bResult = FRAMEDsrcList1->MyItsDsrcManager->InsertDsrc(pObj);
            if (bResult)
            {
                FRAMEDsrcList1->MyItsDsrcManager->FLists.Push(sId, pObj);
            }
		}
        else
		{
            bResult = FRAMEDsrcList1->MyItsDsrcManager->UpdateDsrc(sOldRseId, pObj);
		}

        if (bResult)
        {
            Application->MessageBox(L"DSRC-RSE 정보저장\r\nDSRC-RSE 정보를 저장 하였습니다.",
                                    FTitle.c_str(), MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);

            FUpdate = true;

            FRAMEDsrcList1->UpdateList();
            UpdateRseIcon();
            CMM_SetGridRow(FRAMEDsrcList1->CxList, FRAMEDsrcList1->TvList, sId, FRAMEDsrcList1->Column01->Index);
            DisplayInfo(pObj);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TDSRM010M::BtnSaveAllClick(TObject *Sender)
{
    String sMsg;
    sMsg = "";
    sMsg+= "\r\n수집 이상 기준 정보를 전체 적용 하시겠습니까?";

    if (Application->MessageBox(sMsg.c_str(), FTitle.c_str(), MB_YESNO|MB_ICONQUESTION|MB_APPLMODAL) != IDYES) return;

    int nCLCT_ABNR_BASI = (SeAbnrAll->Value);
    if (FRAMEDsrcList1->MyItsDsrcManager->UpdateClctAbnrBasi(nCLCT_ABNR_BASI))
	{
        SeCLCT_ABNR_BASI->Value = SeAbnrAll->Value;
        FUpdate = true;

        Application->MessageBox(L"수집 이상 기준\r\n수집 이상 기준 정보를 저장 하였습니다.",
                                FTitle.c_str(), MB_OK|MB_ICONINFORMATION|MB_APPLMODAL);
	}
}
//---------------------------------------------------------------------------

